Live Needle Gauge in JavaScript

Using ApexCharts with JavaScript

This Live Needle Gauge example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [86],
  chart: {
    height: 360,
    type: 'gauge',
    animations: {
      enabled: true,
      dynamicAnimation: { enabled: true, speed: 800 },
    },
  },
  colors: ['#00A86F'],
  plotOptions: {
    radialBar: {
      shape: 'needle',
      startAngle: -90,
      endAngle: 90,
      min: 0,
      max: 100,
      ticks: {
        show: true,
        major: {
          count: 11,
          length: 0,
          width: 0,
          color: 'transparent',
          placement: 'outside',
        },
        minor: {
          count: 0,
          length: 0,
          width: 0,
          color: 'transparent',
        },
        labels: {
          show: true,
          offset: 25,
          fontSize: '12px',
          fontWeight: 500,
          color: '#0F172A',
          formatter: function (v) {
            return v + '%'
          },
        },
      },
      needle: {
        color: '#1E293B',
        length: '85%',
        baseWidth: 10,
        tipWidth: 1,
        showValueArc: true,
      },
      track: {
        show: true,
        background: '#ddd',
        strokeWidth: '100%',
        margin: 0,
      },
      hollow: {
        margin: 0,
        size: '70%',
        background: 'transparent',
      },
      dataLabels: {
        name: { show: false },
        value: {
          offsetY: 20,
          fontSize: '16px',
          fontWeight: 700,
          color: '#0F172A',
          formatter: function (val) {
            return val + '%'
          },
        },
      },
    },
  },
  stroke: {
    lineCap: 'butt',
  },
  labels: ['CPU Load'],
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

window.setInterval(function () {
  var next = Math.floor(Math.random() * 101)
  chart.updateSeries([next])
}, 2000)

Live Needle Gauge in React

Using ApexCharts with React

This Live Needle Gauge example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [86],
    options: {
      chart: {
        height: 360,
        type: 'gauge',
        animations: {
          enabled: true,
          dynamicAnimation: { enabled: true, speed: 800 },
        },
      },
      colors: ['#00A86F'],
      plotOptions: {
        radialBar: {
          shape: 'needle',
          startAngle: -90,
          endAngle: 90,
          min: 0,
          max: 100,
          ticks: {
            show: true,
            major: {
              count: 11,
              length: 0,
              width: 0,
              color: 'transparent',
              placement: 'outside',
            },
            minor: {
              count: 0,
              length: 0,
              width: 0,
              color: 'transparent',
            },
            labels: {
              show: true,
              offset: 25,
              fontSize: '12px',
              fontWeight: 500,
              color: '#0F172A',
              formatter: function (v) {
                return v + '%'
              },
            },
          },
          needle: {
            color: '#1E293B',
            length: '85%',
            baseWidth: 10,
            tipWidth: 1,
            showValueArc: true,
          },
          track: {
            show: true,
            background: '#ddd',
            strokeWidth: '100%',
            margin: 0,
          },
          hollow: {
            margin: 0,
            size: '70%',
            background: 'transparent',
          },
          dataLabels: {
            name: { show: false },
            value: {
              offsetY: 20,
              fontSize: '16px',
              fontWeight: 700,
              color: '#0F172A',
              formatter: function (val) {
                return val + '%'
              },
            },
          },
        },
      },
      stroke: {
        lineCap: 'butt',
      },
      labels: ['CPU Load'],
    },
  })

  useEffect(() => {
    const id = window.setInterval(() => {
      setState((s) => ({ ...s, series: [Math.floor(Math.random() * 101)] }))
    }, 2000)
    return () => window.clearInterval(id)
  }, [])

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="gauge"
          height={360}
        />
      </div>
    </div>
  )
}

export default ApexChart

Live Needle Gauge in Angular

Using ApexCharts with Angular

This Live Needle Gauge example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [86],
          chart: {
            height: 360,
            type: 'gauge',
            animations: {
              enabled: true,
              dynamicAnimation: { enabled: true, speed: 800 },
            },
          },
          colors: ['#00A86F'],
          plotOptions: {
            radialBar: {
              shape: 'needle',
              startAngle: -90,
              endAngle: 90,
              min: 0,
              max: 100,
              ticks: {
                show: true,
                major: {
                  count: 11,
                  length: 0,
                  width: 0,
                  color: 'transparent',
                  placement: 'outside',
                },
                minor: {
                  count: 0,
                  length: 0,
                  width: 0,
                  color: 'transparent',
                },
                labels: {
                  show: true,
                  offset: 25,
                  fontSize: '12px',
                  fontWeight: 500,
                  color: '#0F172A',
                  formatter: (v) => {
                    return v + '%'
                  },
                },
              },
              needle: {
                color: '#1E293B',
                length: '85%',
                baseWidth: 10,
                tipWidth: 1,
                showValueArc: true,
              },
              track: {
                show: true,
                background: '#ddd',
                strokeWidth: '100%',
                margin: 0,
              },
              hollow: {
                margin: 0,
                size: '70%',
                background: 'transparent',
              },
              dataLabels: {
                name: { show: false },
                value: {
                  offsetY: 20,
                  fontSize: '16px',
                  fontWeight: 700,
                  color: '#0F172A',
                  formatter: (val) => {
                    return val + '%'
                  },
                },
              },
            },
          },
          stroke: {
            lineCap: 'butt',
          },
          labels: ['CPU Load'],
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');

    window.setInterval(() => {
            var next = Math.floor(Math.random() * 101)
            this.chart.updateSeries([next])
          }, 2000)
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Live Needle Gauge in Vue

Using ApexCharts with Vue

This Live Needle Gauge example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="gauge"
        height="360"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
components: {
apexchart: VueApexCharts,
},
data: function () {
return {
series: [86],
chartOptions: {
chart: {
  height: 360,
  type: 'gauge',
  animations: {
    enabled: true,
    dynamicAnimation: { enabled: true, speed: 800 },
  },
},
colors: ['#00A86F'],
plotOptions: {
  radialBar: {
    shape: 'needle',
    startAngle: -90,
    endAngle: 90,
    min: 0,
    max: 100,
    ticks: {
      show: true,
      major: {
        count: 11,
        length: 0,
        width: 0,
        color: 'transparent',
        placement: 'outside',
      },
      minor: {
        count: 0,
        length: 0,
        width: 0,
        color: 'transparent',
      },
      labels: {
        show: true,
        offset: 25,
        fontSize: '12px',
        fontWeight: 500,
        color: '#0F172A',
        formatter: function (v) {
          return v + '%'
        },
      },
    },
    needle: {
      color: '#1E293B',
      length: '85%',
      baseWidth: 10,
      tipWidth: 1,
      showValueArc: true,
    },
    track: {
      show: true,
      background: '#ddd',
      strokeWidth: '100%',
      margin: 0,
    },
    hollow: {
      margin: 0,
      size: '70%',
      background: 'transparent',
    },
    dataLabels: {
      name: { show: false },
      value: {
        offsetY: 20,
        fontSize: '16px',
        fontWeight: 700,
        color: '#0F172A',
        formatter: function (val) {
          return val + '%'
        },
      },
    },
  },
},
stroke: {
  lineCap: 'butt',
},
labels: ['CPU Load'],
},
}
},
mounted() {
  this.tickId = window.setInterval(() => {
    this.series = [Math.floor(Math.random() * 101)]
  }, 2000)
},
beforeDestroy() {
  if (this.tickId) window.clearInterval(this.tickId)
},,
}
</script>

<style>
#chart {
  padding: 0;
  max-width: 560px;
  margin: 35px auto;
}
</style>